Index: /branches/SHM-dev/build/linux/lib/TLibEncoder/makefile
===================================================================
--- /branches/SHM-dev/build/linux/lib/TLibEncoder/makefile	(revision 1298)
+++ /branches/SHM-dev/build/linux/lib/TLibEncoder/makefile	(revision 1299)
@@ -46,5 +46,4 @@
 			$(OBJ_DIR)/TEncBinCoderCABACCounter.o \
 			$(OBJ_DIR)/TEncSampleAdaptiveOffset.o \
-			$(OBJ_DIR)/TEncAnalyze.o \
 			$(OBJ_DIR)/TEncCavlc.o \
 			$(OBJ_DIR)/TEncCu.o \
Index: /branches/SHM-dev/build/vc10/TLibEncoder_vc10.vcxproj
===================================================================
--- /branches/SHM-dev/build/vc10/TLibEncoder_vc10.vcxproj	(revision 1298)
+++ /branches/SHM-dev/build/vc10/TLibEncoder_vc10.vcxproj	(revision 1299)
@@ -149,5 +149,4 @@
     <ClCompile Include="..\..\source\Lib\TLibEncoder\SyntaxElementWriter.cpp" />
     <ClCompile Include="..\..\source\Lib\TLibEncoder\TEnc3DAsymLUT.cpp" />
-    <ClCompile Include="..\..\source\Lib\TLibEncoder\TEncAnalyze.cpp" />
     <ClCompile Include="..\..\source\Lib\TLibEncoder\TEncBinCoderCABAC.cpp" />
     <ClCompile Include="..\..\source\Lib\TLibEncoder\TEncBinCoderCABACCounter.cpp" />
Index: /branches/SHM-dev/build/vc10/TLibEncoder_vc10.vcxproj.filters
===================================================================
--- /branches/SHM-dev/build/vc10/TLibEncoder_vc10.vcxproj.filters	(revision 1298)
+++ /branches/SHM-dev/build/vc10/TLibEncoder_vc10.vcxproj.filters	(revision 1299)
@@ -19,7 +19,4 @@
     </ClCompile>
     <ClCompile Include="..\..\source\Lib\TLibEncoder\SyntaxElementWriter.cpp">
-      <Filter>Source Files</Filter>
-    </ClCompile>
-    <ClCompile Include="..\..\source\Lib\TLibEncoder\TEncAnalyze.cpp">
       <Filter>Source Files</Filter>
     </ClCompile>
Index: anches/SHM-dev/source/Lib/TLibEncoder/TEncAnalyze.cpp
===================================================================
--- /branches/SHM-dev/source/Lib/TLibEncoder/TEncAnalyze.cpp	(revision 1298)
+++ 	(revision )
@@ -1,48 +1,0 @@
-/* The copyright in this software is being made available under the BSD
- * License, included below. This software may be subject to other third party
- * and contributor rights, including patent rights, and no such rights are
- * granted under this license.
- *
- * Copyright (c) 2010-2015, ITU/ISO/IEC
- * All rights reserved.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions are met:
- *
- *  * Redistributions of source code must retain the above copyright notice,
- *    this list of conditions and the following disclaimer.
- *  * Redistributions in binary form must reproduce the above copyright notice,
- *    this list of conditions and the following disclaimer in the documentation
- *    and/or other materials provided with the distribution.
- *  * Neither the name of the ITU/ISO/IEC nor the names of its contributors may
- *    be used to endorse or promote products derived from this software without
- *    specific prior written permission.
- *
- * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
- * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
- * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
- * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS
- * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
- * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
- * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
- * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
- * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
- * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
- * THE POSSIBILITY OF SUCH DAMAGE.
- */
-
-/** \file     TEncAnalyze.cpp
-    \brief    encoder analyzer class
-*/
-
-#include "TEncAnalyze.h"
-
-//! \ingroup TLibEncoder
-//! \{
-
-//////////////////////////////////////////////////////////////////////
-// Construction/Destruction
-//////////////////////////////////////////////////////////////////////
-
-
-//! \}