Index: branches/HTM-14.1-update-dev1/source/Lib/TLibCommon/TComRom.cpp
===================================================================
--- branches/HTM-14.1-update-dev1/source/Lib/TLibCommon/TComRom.cpp	(revision 1310)
+++ branches/HTM-14.1-update-dev1/source/Lib/TLibCommon/TComRom.cpp	(revision 1311)
@@ -551,6 +551,6 @@
 Bool g_decTraceMvFromMerge     = false; 
 Bool g_decTracePicOutput       = false; 
-Bool g_startStopTrace          = true; 
-Bool g_outputPos               = false;   
+Bool g_startStopTrace          = false; 
+Bool g_outputPos               = false;
 Bool g_traceCameraParameters   = false; 
 Bool g_encNumberOfWrittenBits  = false; 
@@ -691,5 +691,4 @@
               << std::endl; 
   }
-
   Bool startTrace = false; 
   if ( g_startStopTrace && poc == 0 && layerId == 0 )
@@ -707,5 +706,4 @@
     g_traceCopyBack          = false; 
   }  
-
   Bool stopTrace = false; 
   if ( g_startStopTrace && poc == 0 && layerId == 0 )
@@ -767,5 +765,4 @@
   }
 }
-
 Void prinStrIncIndent( Bool b,  std::string strStr )
 {
@@ -779,5 +776,4 @@
   }  
 }
-
 Void decIndent( Bool b )
 {
@@ -787,5 +783,4 @@
   }  
 }
-
 #endif
 #endif
Index: branches/HTM-14.1-update-dev1/source/Lib/TLibCommon/TComSlice.cpp
===================================================================
--- branches/HTM-14.1-update-dev1/source/Lib/TLibCommon/TComSlice.cpp	(revision 1310)
+++ branches/HTM-14.1-update-dev1/source/Lib/TLibCommon/TComSlice.cpp	(revision 1311)
@@ -3905,6 +3905,6 @@
     if ( g_traceCameraParameters )
     {
-      std::cout << std::endl << "Cp: " << codScale   [ iInVoi ] << " " <<    codOffset[ iInVoi ] << " "
-                << invCodScale[ iInVoi ] << " " << invCodOffset[ iInVoi ] << " " << log2Div; 
+      std::cout << "Cp: " << codScale   [ iInVoi ] << " " <<    codOffset[ iInVoi ] << " "
+                << invCodScale[ iInVoi ] << " " << invCodOffset[ iInVoi ] << " " << log2Div << std::endl ; 
     }
 #endif
Index: branches/HTM-14.1-update-dev1/source/Lib/TLibCommon/TComSlice.h
===================================================================
--- branches/HTM-14.1-update-dev1/source/Lib/TLibCommon/TComSlice.h	(revision 1310)
+++ branches/HTM-14.1-update-dev1/source/Lib/TLibCommon/TComSlice.h	(revision 1311)
@@ -2948,8 +2948,8 @@
   Void                        setCamparaSlice       ( Int** aaiScale = 0, Int** aaiOffset = 0 );      
 
-  IntAry1d                    getCodedScale         ()                               { return m_aaiCodedScale [0];                                   }
-  IntAry1d                    getCodedOffset        ()                               { return m_aaiCodedOffset[0];                                   }
-  IntAry1d                    getInvCodedScale      ()                               { return m_aaiCodedScale [1];                                   }
-  IntAry1d                    getInvCodedOffset     ()                               { return m_aaiCodedOffset[1];                                   }
+  IntAry1d                    getCodedScale         () const                         { return m_aaiCodedScale [0];                                   }
+  IntAry1d                    getCodedOffset        () const                         { return m_aaiCodedOffset[0];                                   }
+  IntAry1d                    getInvCodedScale      () const                         { return m_aaiCodedScale [1];                                   }
+  IntAry1d                    getInvCodedOffset     () const                         { return m_aaiCodedOffset[1];                                   }
                                                                                                                                                      
   Void                        setCpScale( Int j, Int  val )                          { m_aaiCodedScale[0][j] = val;                                  }
Index: branches/HTM-14.1-update-dev1/source/Lib/TLibCommon/TypeDef.h
===================================================================
--- branches/HTM-14.1-update-dev1/source/Lib/TLibCommon/TypeDef.h	(revision 1310)
+++ branches/HTM-14.1-update-dev1/source/Lib/TLibCommon/TypeDef.h	(revision 1311)
@@ -67,4 +67,5 @@
 #if NH_MV
 
+#define NH_3D_FIX_TICKET_101              ( 1 && NH_3D_VER141_DEC_COMP_FLAG )  // Camera parameters for depth
 #define NH_MV_FIX_TICKET_105              1 // layer_set_idx_for_ols_minus1 length
 #define NH_3D_FIX_TICKET_98               1 // Writing of depth intra skip flag